﻿using System;

namespace WebsiteWithEmailer
{
    using System.IO;
    using System.Net.Mail;
    using System.Threading.Tasks;

    using RazorEngine;

    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            // we will send an email in a background thread
            Task.Factory.StartNew(
                () =>
                {
                    // All of the code below runs in a background thread.

                    // get the template file.
                    var templateLocation =
                        Path.Combine(
                            AppDomain.CurrentDomain.BaseDirectory,
                            @"EmailTemplates\AnEmailTemplate.html");

                    // read contents of file.
                    string template = File.ReadAllText(templateLocation);

                    // set the subject.
                    string subject = "Testing Emails";

                    // render the body of the email using razorengine.
                    string emailBody = Razor.Parse(template, new
                    {
                        Subject = subject,
                        FirstName = "Bob",
                        Message = "This is a test email message I am sending to you.",
                        FromName = "Sean"
                    });

                    // create an smptp client and send the email
                    SmtpClient client = new SmtpClient();
                    client.Host = "mail.yourserver.com";
                    MailMessage mm = new MailMessage();
                    mm.Sender = new MailAddress("foo@bar.com", "Foo Bar");
                    mm.From = new MailAddress("foo@bar.com", "Foo Bar");
                    mm.To.Add(new MailAddress("foo@bar.com", "Foo Bar"));
                    mm.Subject = subject;
                    mm.Body = emailBody;
                    mm.IsBodyHtml = true;
                    client.Send(mm);
                });
        }
    }
}